<?php

include "../B4XSerializator.php";

$arr = array('nom'=>'Willy', 'age'=>new B4XNumeric(67, B4XSerializator::T_SHORT), 'married'=>'Yes', 'children' => 4);
$ser = new B4XSerializator(true);
$mytype = new B4XType('MyTypeFromPhp', $arr);

echo "Testing User Defined Type: \r\n";
$b = $ser->ConvertObjectToBytes($mytype);
$obj = $ser->ConvertBytesToObject($b);
var_dump($obj);

echo "Testing Byte Array: \r\n";
$b = $ser->ConvertObjectToBytes($ser->B4XBytes($ser->ConvertObjectToBytes("Testing Byte Array")));
$obj = $ser->ConvertBytesToObject($b);
$obj = $ser->ConvertBytesToObject($obj);
var_dump($obj);

echo "Testing Array: \r\n";
$b = $ser->ConvertObjectToBytes($arr);
$obj = $ser->ConvertBytesToObject($b);
var_dump($obj);

echo "Testing String: \r\n";
$b = $ser->ConvertObjectToBytes('早上好');
$obj = $ser->ConvertBytesToObject($b);
var_dump($obj);

echo "Testing Float number: \r\n";
$b = $ser->ConvertObjectToBytes(98.65);
$obj = $ser->ConvertBytesToObject($b);
var_dump($obj);

echo "Testing Int: \r\n";
$b = $ser->ConvertObjectToBytes(-89);
$obj = $ser->ConvertBytesToObject($b);
var_dump($obj);

echo "Testing Boolean: \r\n";
$b = $ser->ConvertObjectToBytes(true);
$obj = $ser->ConvertBytesToObject($b);
var_dump($obj);

echo "Testing Long: \r\n";
$b = $ser->ConvertObjectToBytes(new B4XNumeric(198, B4XSerializator::T_LONG));   //T_LONG type: available only on 64bits versions of php
$obj = $ser->ConvertBytesToObject($b);
var_dump($obj);
